#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

using namespace std;

#if 0
void fA() {
  int n, m;
  cin >> n >> m;
  if (n - 7 >= 1)
      cout << n - 7;
  else
      cout << m + 7;
}
#endif

int64_t count_bits(int64_t n)
{
    int64_t res {0};

    for (int64_t i {0}; i < 0x40; i++)
        res += (n >> i) & 1;

    return res;
}

void fE()
{
    int64_t n;
    cin >> n;

    while (n-- > 0)
    {
        int64_t val;

        cin >> val;

        val = abs(val);

        int64_t up {val};
        up |= (up >> 0x1);
        up |= (up >> 0x2);
        up |= (up >> 0x4);
        up |= (up >> 0x8);
        up |= (up >> 0x10);
        up |= (up >> 0x20);

        up = (up ^ (up >> 1)) << 1;

        int64_t down {up >> 1};
        up = up - val;
        down = val - down;

        cout << ((val == 0) ? 0 : std::min(count_bits(up), count_bits(down)) + 1) << "\n";
    }
}


int main() {
    fE();
    return 0;
}
