#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>


using namespace std;

int INF = 1e9 + 1;

vector<int> tree, a;

void build(int i, int l, int r) {
	if (l + 1 == r) tree[i] = a[l];
	else {
		int k = (l + r) / 2;
		build(2 * i + 1, l, k);
		build(2 * i + 2, k, r);
		tree[i] = min(tree[2 * i + 1], tree[2 * i + 2]);
	}
}

int getmin(int i, int l, int r, int ql, int qr) {
	if(qr <= l || r <= ql)return INF;
	if (ql <= l && r <= qr) return tree[i];
	int k = (l + r) / 2;
	return min(getmin(2 * i + 1, l, k, ql, qr), getmin(2 * i + 2, k, r, ql, qr));
}

int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		long long x; 
		int ans = 0;
		cin >> x;
		x = abs(x);
		while (x > 0) {
			long long h = 1;
			while (2 * h <= x) h *= 2;
			if (2 * h - x < x - h) {
				x = 2 * h - x;
			}
			else {
				x = x - h;
			}
			ans++;
		}
		cout << ans << "\n";
	}
}