#include <iostream>
#include <cmath>
#include <vector>

long long inNum(long long a) {
	if (a == 0) return 1;
	int i = 0;
	while (a > 0) {
		i++;
		a /= 10;
	}
	return i;
}

long long pow(long long a, long long n) {
	if (n == 0) return 1;
	if (n == 1) return a;
	long long d = pow(a, n / 2);
	d *= d;
	if (n % 2 == 1) d *= a;
	return d;
}

int main() {
	long long s;
	std::cin >> s;
	std::vector<long long> a(18, 1);
	a[1] = 10;
	long long t = 9;
	for (int i = 2; i < 18; i++)
	{
		t *= 10;
		a[i] = a[i - 1] + t * i;
	}
	//for (int i = 0; i < 18; i++) std::cout << a[i] << std::endl;
	int mini = 0;
	while (s >= a[mini + 1]) mini++;
	long long x = 0;
	while (true) {
		if ((s - a[mini]) % (mini + 1) == 0) {
			long long d = (s - a[mini]) / (mini + 1);
			long long ans = pow(10, mini) - 1 + d;
			std::cout << ans - x + 1 << std::endl;
			std::cout << x << " " << ans;
			return 0;
		}
		s += inNum(x);
		if (s >= a[mini + 1]) mini++;
		x++;
	}
}