#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>


using namespace std;

int INF = 1e9 + 1;

vector<int> tree, a;

void build(int i, int l, int r) {
	if (l + 1 == r) tree[i] = a[l];
	else {
		int k = (l + r) / 2;
		build(2 * i + 1, l, k);
		build(2 * i + 2, k, r);
		tree[i] = min(tree[2 * i + 1], tree[2 * i + 2]);
	}
}

int getmin(int i, int l, int r, int ql, int qr) {
	if(qr <= l || r <= ql)return INF;
	if (ql <= l && r <= qr) return tree[i];
	int k = (l + r) / 2;
	return min(getmin(2 * i + 1, l, k, ql, qr), getmin(2 * i + 2, k, r, ql, qr));
}

int main() {
	int n;
	cin >> n;
	vector<int> a(n + 1);
	for (int i = 0; i < n + 1; i++)
		a[i] = i + 1;
	string s;
	cin >> s;
	bool t = true;
	for (int i = 0; i < n; i++)
	{
		if (s[i] == 'A')
		{
			if (t) swap(a[i], a[i + 1]);
			t = !t;
		}
	}
	for (int i = 0; i < n + 1; i++) cout << a[i] << " ";
}