#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>

using namespace std;

class hsh {
	string str;

	long long osn = 1e9 + 7;
	long long mod = 1e9 + 9;

	int size;

	vector<long long> osn1;
	vector<long long> hsh1;

	hsh(string _str)
	{
		str = _str;
		size = str.size();
		osn1.resize(size + 1);
		osn1[0] = 1;
		hsh1.resize(size + 1);
		hsh1[0] = 0;

		for (int i = 1; i < size + 1; ++i)
		{
			osn1[i] = osn1[i - 1] * osn;
		}

		for (int i = 0; i < size; ++i)
		{
			hsh1[i + 1] = hsh1[i] + str[i] * osn1[i];
		}
	}


};

int main()
{
	int t;
	cin >> t;

	for (int y = 0; y < t; ++y)
	{
		long long x;
		cin >> x;
		x = abs(x);
		int a = 0, b = 0, c = 0;
		long long ans = 0;
		int k = 0;

		while (x % 2 == 0) {
			x /= 2;
		}

		while (x > 0)
		{
			if (x % 2 == 0)
			{
				++a;
				if (k == 1)
				{
					++b;
				}
				if (k >= 2)
				{
					++c;
				}
				k = 0;
			}
			else {
				++k;
			}

			x /= 2;

		}

		if (k == 1)
		{
			++b;
		}
		if (k >= 2)
		{
			++c;
		}

		cout << min(a + 2, b + 2 * c) << endl;
	}
	return 0;
}