class Tree:
    def __init__(self, father=None):
        self.color = -1
        self.father = father
        self.l = None
        self.r = None

    def add_r(self, object1):
        self.r = object1
        object1.father = self
        if self.color != -1:
            object1.color = (self.color - 1 + c) % c

    def add_l(self, object1):
        self.l = object1
        object1.father = self
        if self.color != -1:
            object1.color = (self.color + 1) % c

    def change_color(self, color1):
        self.color = color1
        object_now_funk = self.l
        while object_now_funk is not None:
            object_now_funk.color = (object_now_funk.father.color + 1) % c
            object_now_funk = object_now_funk.l

        object_now_funk = self.r
        while object_now_funk is not None:
            object_now_funk.color = (object_now_funk.father.color - 1 + c) % c
            object_now_funk = object_now_funk.r


"""
first_line = Tree()
second = Tree()
third = Tree()
fourth = Tree()
fifth = Tree()
first_line.add_r(third)
first_line.add_l(second)
second.add_l(fourth)
second.add_r(fifth)
first_line.change_color(2)
print(first_line.color, second.color, third.color, fourth.color, fifth.color)
"""
q, c = map(int, input().split())
start = Tree()
for _ in range(q):
    line = input()
    if line[0] == "1":
        a, color = line.split()
        dire = input()
        object_now1 = start
        for i in range(len(dire)):
            if dire[i] == "L":
                if object_now1.l is None:
                    object_now1.add_l(Tree(object_now1))
                object_now1 = object_now1.l
            else:
                if object_now1.r is None:
                    object_now1.add_r(Tree(object_now1))
                object_now1 = object_now1.r
        object_now1.change_color(int(color))
    else:
        dire = input()
        object_now1 = start
        for i in range(len(dire)):
            if dire[i] == "L":
                if object_now1.l is None:
                    object_now1.add_l(Tree(object_now1))
                object_now1 = object_now1.l
            else:
                if object_now1.r is None:
                    object_now1.add_r(Tree(object_now1))
                object_now1 = object_now1.r
        print(object_now1.color)


"""

6 3
1 2
L
2
LL
0
1 0
LL
2
LLR
2
LR
2
R"""