import java.io.*;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class ProblemH {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
        int n = Integer.parseInt(reader.readLine());
        String str = reader.readLine();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) a[i] = str.charAt(i) == 'A' ? 0 : 1;
        int[] h = new int[n + 1];
        int mid = n / 2;
        int count = 0;
        for (int i = 0; i < mid; i++) {
            if (a[i] == 0) {
                if (h[i] == 0) count++;
                h[i] = count;
                h[i + 1] = ++count;
            }
        }
        count = n + 1;
        for (int i = mid; i < n; i++) {
            if (a[i] == 0) {
                if (i > mid && h[i] == 0) count--;
                h[i] = count;
                h[i + 1] = --count;
            }
        }
        Set<Integer> set = new HashSet<>();
        for (int i = 1; i <= n + 1; i++) set.add(i);
        for (int i = 0; i < n + 1; i++) set.remove(h[i]);
        List<Integer> list = new ArrayList<>(set);
        int c = 0;
        for (int i = 0; i < n + 1; i++) if (h[i] == 0) h[i] = list.get(c++);
        for (int i = 0; i < n + 1; i++) writer.write(h[i] + " ");
        writer.flush();
    }
}
