#include <iostream>
#include <cmath>
#include <climits>
#include <vector>
#include <map>

using namespace std;

__int64 min(__int64 a, __int64 b) {
	if (a >= b) {
		return b;
	}
	else {
		return a;
	}
}

__int64 max(__int64 a, __int64 b) {
	if (a <= b) {
		return b;
	}
	else {
		return a;
	}
}
map <__int64, __int64> proccesed;
int howToGet(__int64 t, int* count) {
	if (t == 0) {
		return 0;
	}
	if (t == 1) {
		return 1;
	}
	if (proccesed[t] != 0) {
		return proccesed[t];
	}
	if (*count > 65 || t < 0) {
		return INT_MAX;
	}
	double res = log2f((double) t);
	int up = ceil(res);
	int down = floor(res);
	*count = *count + 1;
	//cout << res << ' ' << up << ' ' << down << ' ' << t << ' ' << *count << endl;
	proccesed[t] = 1 + min(howToGet((__int64)pow(2, up) - t, count), howToGet((__int64)t - pow(2, down), count));
	return proccesed[t];
}

int main()
{
	int n; cin >> n; __int64* nums = new __int64[n];
	__int64 m = INT_MIN;
	for (int i = 0; i < n; i++) {
		cin >> nums[i];
		m = max(nums[i], m);
	}
	
	for (int i = 0; i < n; i++) {
		int* count = new int;
		*count = 0;
		cout << howToGet(abs(nums[i]), count) << endl;
	}

}