#include <iostream>
#include <cmath>
#include <climits>
#include <vector>
#include <map>

using namespace std;

__int64 min(__int64 a, __int64 b) {
	if (a >= b) {
		return b;
	}
	else {
		return a;
	}
}

__int64 max(__int64 a, __int64 b) {
	if (a <= b) {
		return b;
	}
	else {
		return a;
	}
}
__int64 twos[64];
map <__int64, __int64> proccesed;
int howToGet(__int64 t) {
	if (t == 0) {
		return 0;
	}
	if (t == 1) {
		return 1;
	}
	if (proccesed[t] != 0) {
		return proccesed[t];
	}
	if (t < 0) {
		return INT_MAX;
	}
	double res = log2f((double) t);
	int up = ceil(res);
	int down = floor(res);
	//*count = *count + 1;
	//cout << res << ' ' << up << ' ' << down << ' ' << t << ' ' << *count << endl;
	proccesed[t] = 1 + min(howToGet((__int64) twos[up] - t), howToGet((__int64)t - twos[down]));
	return proccesed[t];
}

int main()
{
	ios::sync_with_stdio;
	cin.tie(0);

	int n; cin >> n; __int64* nums = new __int64[n];

	for (int i = 0; i < 64; i++) {
		twos[i] = pow(2, i);
	}
	for (int i = 0; i < n; i++) {
		cin >> nums[i];
		cout << howToGet(abs(nums[i])) << endl;
	}	
}