#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
template<class T> using oset = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define int ll
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()
const int N = 1e5 + 100;
int T[N* 4];
void build(int p, int l, int r, vector<int> &a) {
    if (l + 1 == r) {
        T[p] = a[l];
        return;
    }
    int mid = (l + r) / 2;
    build(p * 2 + 1, l, mid, a);
    build(p * 2 + 2, mid, r, a);
    T[p] = min(T[p * 2 + 1], T[p * 2 + 2]);
}
int query(int p, int l, int r, int ql, int qr) {
    if (ql <= l && qr >= r) {
        return T[p];
    }
    if (ql >= r || qr <= l) {
        return 1e10;
    }
    int mid = (l + r) / 2;
    return min(query(p * 2 + 1, l, mid, ql, qr), query(p * 2 + 2, mid, r, ql,qr));
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int>  a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    build(0,0,n + 1,a);
    vector<int> prefs(n + 1);
    for (int i = 0; i < n; ++i) {
        prefs[i + 1] = prefs[i] + a[i];
    }
    auto sum = [&](int l, int r) {
        return prefs[r] - prefs[l];
    };
    int S = (accumulate(all(a), 0ll) - 1) / 2 + 1;
    int l = 0, r = n;
    int ans = 1e9;

    while(r - l > 1) {
        int mid = (l + r) / 2;
        bool ok = false;
        for (int i = 0; i + mid <= n; ++i) {
            int col = sum(i , i + mid);
            int mn = query(0,0,n + 1,i, i + mid);
            if (col - mn >= S) {
                ans = min (ans, mid - 1);
                r = mid;
                ok = true;
                break;
            }
        }
        if (!ok ){
            l = mid;
        }
    }
    l = -1;
    r = n;
    while(r - l > 1) {
        int mid = (l + r) / 2;
        bool ok = false;
        for (int i = 0; i + mid <= n; ++i) {
            int col = sum(i , i + mid);
            if (col >= S) {
                ans = min (ans, mid);
                r = mid;
                ok = true;
                break;
            }
        }
        if (!ok){
            l = mid;
        }
    }
    cout << ans << endl;

}
/*

5
1 1 2 1 2
 */
