#include <vector>
#include <iostream>
#include <string>
#include <set>

using namespace std;
typedef long long ll;
set<ll> s;

void solve() {
	ll x;
	cin >> x;
	int ans = 0;
	while (x != 0) {
		auto l = *(--s.lower_bound(x)), r = *(s.lower_bound(x));
		if (abs(x - l) <= abs(x - r)) {
			x = abs(x - l);
		}
		else {
			x = abs(x - r);
		}
		ans++;
	}
	cout << ans << endl;
}

int main()
{
	ios::sync_with_stdio(false);
	cout.tie(0);
	cin.tie(0);
	ll a = 1;
	s.insert(0);
	s.insert(-1);
	s.insert(1);
	for (int i = 1; i <= 60; i++) {
		a *= 2;
		s.insert(a);
		s.insert(-a);
	}
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}