﻿#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long TYPE;

TYPE Sum(vector<TYPE> A) {
	TYPE res = 0;
	for (int i = 0; i < A.size(); i++) {
		res += A[i];
	}
	return res;
}

TYPE Min(vector<TYPE> A, int L, int R) {
	TYPE res = A[0];
	for (int i = L; i < R; i++) {
		if (res > A[i])
			res = A[i];
	}
	return res;
}


int main() {
	int N;
	
	cin >> N;
	vector<TYPE> dp(N);
	for (int i = 0; i < N; i++) {
		cin >> dp[i];
	}
	TYPE Summ = (Sum(dp) + 1) / 2;

	for (int i = 0; i < N; i++) {
		if (dp[i] >= Summ) {
			cout << 1;
			return 0;
		}
	}

	int MinCnt = 1000000000;

	TYPE res = 0;
	int cnt = 0;
	int m = 0;
	for (int i = 0; i < dp.size(); i++) {
		res = 0;
		cnt = 0;
		for (int j = i; j < dp.size(); j++) {
			res += dp[j];
			cnt++;
			if (res >= Summ) {
				if ((res -= (m = Min(dp, i, j))) >= Summ) {
					cnt--;
					break;
				}
				else {
					res += m;
				}
				
			}
		}

		if (MinCnt > cnt && res >= Summ) {
			MinCnt = cnt;
		}
	}

	cout << MinCnt;
}
