#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <cmath>

using namespace std;
typedef long long LL;

inline int min(int a, int b)
{
  return a < b ? a : b;
}

inline int max(int a, int b)
{
  return a > b ? a : b;
}


//                              x  , i
std::map<std::string, std::pair<int, int>> A;


bool IsOnWay(const string& Ai, const string& Ax)
{
  if (Ai.size() > Ax.size())
    return 0;
  for (int i = 0; i < (int)Ai.size(); i++)
  {
    if (Ai[i] != Ax[i])
      return 0;
  }
  return 1;
}

int main(void)
{
  LL q, c;

  cin >> q;
  cin >> c;

  for (int i = 0; i <= q; i++)
  {
    int Comand, x;
    cin >> Comand;

    if (Comand == 1)
    {
      cin >> x;

      string Way;
      cin >> Way;

      A[Way] = {x, i};
    }
    else if (Comand == 2)
    {
      string OWay {};
      pair<int, int> OCom;

      string XWay;
      cin >> XWay;

      for (auto& Ai : A)
      {
        if (IsOnWay(Ai.first, XWay))
        {
          if (OWay == "")
            OWay = Ai.first, OCom = Ai.second;
          else if (OCom.second < Ai.second.second)
            OWay = Ai.first, OCom = Ai.second;
        }
      }

      if (OWay == "")
        cout << -1 << endl;
      else
      {
        int TempWayI = OWay.size();
        LL OutColor = OCom.first;

        while (TempWayI < (int)XWay.size())
        {
          if (XWay[TempWayI] == 'L')
            OutColor = abs(OutColor + 1) % c;
          else if (XWay[TempWayI] == 'R')
            OutColor = abs(OutColor - 1 + c) % c;
          TempWayI++;
        }
        cout << OutColor << endl;
      }
    }

  }
  return 0;
}


/*
int main(void)
{
  int Cnt, i;
  vector<char> W;

  cin >> Cnt;
  i = Cnt;
  W.resize(Cnt);

  while (i--)
  {
    static string Buf;

    cin >> Buf;

    W[i] = Buf[0];
  }

  int s1 = 0;
  for (int f = 0; f < W.size(); f++)
    for (int s = f + 1; s < W.size(); s++)
      s1 += (W[f] == W[s]);
  cout << s1 << endl;

  return 0;
}

/*
vector<string> W;
map<int, int> Sizes; //letters, number of pairs

int Compare(int a, int b)
{
  for (int i = 0; i < W[a].size() && i < W[b].size(); i++)
    if (W[a][i] != W[b][i])
      return i;

  return min(W[a].size(), W[b].size());
}

void ReadWords()
{
  int Cnt, i;

  cin >> Cnt;
  i = Cnt;
  W.resize(Cnt);
  while (i--)
    cin >> W[i];
}

void EvalCounts()
{
  for (int f = 0; f < W.size(); f++)
    for (int s = f + 1; s < W.size(); s++)
    {
      int ccn = Compare(f, s);

      while (ccn > 0)
        Sizes[ccn--]++;
    }
}

int EvalSizes()
{
  int pairs = 0;
  for (auto i : Sizes)
    pairs = max(i.second, pairs);
  return pairs;
}

int main(void)
{
  ReadWords();
  EvalCounts();
  cout << EvalSizes() << endl;
 
  return 0;
}
*/