#include<bits/stdc++.h>

using namespace std;
#define int long long
#define pb push_back


struct ret {
    int x, y, g;

    ret() = default;
};


ret gcd(int a, int b) {
    if (b == 0) {
        return {1, 0, a};
    }
    auto p = gcd(b, a % b);
    return {p.y, p.x - (a / b) * p.y, p.g};
}


int get_ind(int r, int c, int rl, int cl, int rr, int cr) {
    int h = rr - rl;
    int w = cr - cl;
    if (r == rr) {
        return h + c - cl;
    }
    if (r == rl) {
        return 2 * h + w + cr - c;
    }
    if (c == cl) {
        return r - rl;
    }
    if (c == cr) {
        return h + w + rr - r;
    }
}


int get_mod(int x, int mod) {
    x %= mod;
    if (x < 0) x += mod;
    return x;
}

const int inf = 1e17;

void solve() {
    int n;
    cin >> n;
    int rl, cl, rr, cr, rp, cp;
    cin >> rl >> cl >> rr >> cr >> rp >> cp;
    vector<pair<int, int>> p;
    for (int i = 0; i < n; i++) {
        int r, c;
        cin >> r >> c;
        p.emplace_back(r, c);
    }

    int lim = (1 << n);
    int res = inf;
    for (int mask = 0; mask < lim; mask++) {
        {
            bool flag = true;
            // vertical
            vector<pair<int, int>> coef; // mod, a
            for (int i = 1; i <= n; i++) {
                int h = rr - rl + 2 * i;
                int w = cr - cl + 2 * i;
                int start = get_ind(p[i].first, p[i].second, rl - i, cl - i, rr + i, cr + i);
                int needed;
                if (mask & (1 << (i - 1))) {
                    needed = get_ind(rl - i, cp, rl - i, cl - i, rr + i, cr + i);
                } else {
                    needed = get_ind(rr + i, cp, rl - i, cl - i, rr + i, cr + i);
                }
                coef.emplace_back((h + w) * 2, get_mod(needed - start, (h + w) * 2));
            }
            unordered_map<int, pair<int, int>> pr; // prime - <power, a>

            for (auto pa: coef) {
                int m = pa.first;
                for (int i = 2; i * i <= m; i++) {
                    if (m % i) continue;
                    int cnt = 1;
                    while (m % i == 0) {
                        cnt *= i;
                        m /= i;
                    }
                    if (pr.count(i)) {
                        pr[i].first = max(pr[i].first, cnt);
                        if (pr[i].second % pr[i].first != pa.second % pr[i].first) {
                            flag = false;
                            break;
                        }
                    } else {
                        pr[i] = {cnt, pa.second};
                    }
                }
                if (m != 1) {
                    int i = m;
                    if (pr.count(i)) {
                        pr[i].first = max(pr[i].first, m);
                        if (pr[i].second % pr[i].first != pa.second % pr[i].first) {
                            flag = false;
                            break;
                        }
                    } else {
                        pr[i] = {m, pa.second};
                    }
                }
            }
            if (flag) {
                int mod = -1, a = -1;
                for (auto pa: pr) {
                    if (mod == -1) {
                        mod = pa.second.first, a = pa.second.second;
                        continue;
                    }
                    int d = -pa.second.second + a;
                    ret tmp = gcd(pa.second.first, -mod);
                    tmp.x *= d;
                    tmp.y *= d;
                    a = pa.second.second + tmp.x * pa.second.first;
                    mod = mod * pa.second.first;
                }
                int t;
                if (a >= 0) {
                    t = a - mod * (a / mod);
                } else {
                    t = a + mod * ((abs(a) + mod - 1) / mod);
                }
                res = min(t, res);
            }
        }

        {
            bool flag = true;
            // horizontal
            vector<pair<int, int>> coef; // mod, a
            for (int i = 1; i <= n; i++) {
                int h = rr - rl + 2 * i;
                int w = cr - cl + 2 * i;
                int start = get_ind(p[i].first, p[i].second, rl - i, cl - i, rr + i, cr + i);
                int needed;
                if (mask & (1 << (i - 1))) {
                    needed = get_ind(rp, cl - i, rl - i, cl - i, rr + i, cr + i);
                } else {
                    needed = get_ind(rp, cr + i, rl - i, cl - i, rr + i, cr + i);
                }
                coef.emplace_back((h + w) * 2, get_mod(needed - start, (h + w) * 2));
            }
            unordered_map<int, pair<int, int>> pr; // prime - <power, a>
            for (auto pa: coef) {
                int m = pa.first;
                for (int i = 2; i * i <= m; i++) {
                    if (m % i) continue;
                    int cnt = 1;
                    while (m % i == 0) {
                        cnt *= i;
                        m /= i;
                    }
                    if (pr.count(i)) {
                        pr[i].first = max(pr[i].first, cnt);
                        if (pr[i].second % pr[i].first != pa.second % pr[i].first) {
                            flag = false;
                            break;
                        }
                    } else {
                        pr[i] = {cnt, pa.second};
                    }
                }
                if (m != 1) {
                    int i = m;
                    if (pr.count(i)) {
                        pr[i].first = max(pr[i].first, m);
                        if (pr[i].second % pr[i].first != pa.second % pr[i].first) {
                            flag = false;
                            break;
                        }
                    } else {
                        pr[i] = {m, pa.second};
                    }
                }
            }
            if (flag) {
                int mod = -1, a = -1;
                for (auto pa: pr) {
                    if (mod == -1) {
                        mod = pa.second.first, a = pa.second.second;
                        continue;
                    }
                    int d = -pa.second.second + a;
                    ret tmp = gcd(pa.second.first, -mod);
                    tmp.x *= d;
                    tmp.y *= d;
                    a = pa.second.second + tmp.x * pa.second.first;
                    mod = mod * pa.second.first;
                }
                int t;
//                cout << a << '\n';
                if (a >= 0) {
                    t = a - mod * (a / mod);
                } else {
                    t = a + mod * ((abs(a) + mod - 1) / mod);
                }
                res = min(t, res);
            }
        }
    }
    if (res == inf) cout << -1;
    else cout << res;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
}