#include <iostream>
#include <vector>
using namespace std;
#define INF 10000000050
#define ll long long
int n;
vector<ll> values;

struct node
{
    int l;
    int r;
    ll val;

};
vector<node> tree;


int build(int h)
{
    //cout<<h<<' '<<2*h+1<<' '<<2*h+2<<endl;
    if (0 <= h-(n-1))
    {
        if (h - (n-1) >= n)
            tree[h].val = INF;
        else
            tree[h].val = values[h-(n-1)];
        tree[h].l = h-(n-1);
        tree[h].r = h-(n-1);
    }

    else
    {
        tree[h].val = min(build(2*h+1),build(2*h+2));
        tree[h].l = tree[2*h+1].l;
        tree[h].r = tree[2*h+2].r;
    }
    return tree[h].val;
}

int minlr(int l,int r,int node)
{
    if(l>r || tree[node].r < l || tree[node].l > r)
        return INF;
    if(node >= tree.size())
        return INF;
    //cout<<l<<' '<<r<<' '<<node<<' '<<tree[node].l<<'|'<<tree[node].r<<endl;
    if (tree[node].l>=l && tree[node].r<=r)
        return tree[node].val;
    int m =(l+r)/2;

    //if(r<=m)
    //    return minlr(l,r,2*node + 1);
    //if(l>=m)
    //    return minlr(l,r,2*node + 2);

    return min(minlr(l,m,2*node+1),minlr(m,r,2*node+2));
}


int main()
{

    cin >> n;



    values.resize(n);
    ll sum = 0;
    for(int i =0;i<n;i++){
        cin>> values[i];
        sum += values[i];
    }
    sum = (sum + 1) /2;

   tree.resize(4*n);

    tree[0].val = build(0);


  /*  while(true)
    {
        int l,r;
        cin>>l>>r;
        cout<<minlr(l,r,0)<<endl;

    }*/

    ll i = 0, j = 0;
    ll ans = n;
    ll sum_p = values[0];
    while(true)
    {
        if(sum_p >= sum){
            ll sum_min = sum_p - minlr(i,j,0);
            if(sum_min >= sum){
                ans = min(ans, (j - i));
            }else{
                ans = min(ans, (j - i + 1));
            }
            if(i == j){
                break;
            }
            sum_p -= values[i];
            i++;
        }else{
            if(j == n - 1){
                break;
            }
            j++;
            sum_p += values[j];
            //cout << j;
        }
    }
   // cout << i<<' '<<j<<"\n";
    cout << ans;
    return 0;
}
