#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>


using namespace std;

int INF = 1e9 + 1;

vector<int> tree, a;

void build(int i, int l, int r) {
	if (l + 1 == r) tree[i] = a[l];
	else {
		int k = (l + r) / 2;
		build(2 * i + 1, l, k);
		build(2 * i + 2, k, r);
		tree[i] = min(tree[2 * i + 1], tree[2 * i + 2]);
	}
}

int getmin(int i, int l, int r, int ql, int qr) {
	if(qr <= l || r <= ql)return INF;
	if (ql <= l && r <= qr) return tree[i];
	int k = (l + r) / 2;
	return min(getmin(2 * i + 1, l, k, ql, qr), getmin(2 * i + 2, k, r, ql, qr));
}

int main() {
	int n;
	cin >> n;
	a.resize(n);
	tree.resize(4 * n);
	long long half = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		half += a[i];
	}
	half = half / 2 + half % 2;
	build(0, 0, n);
	int r = 0, ans = INF; 
	long long sum = a[0];
	for (int i = 0; i < n; ++i) {
		while (sum < half && r < n - 1) {
			r++;
			sum += a[r];
		}
		int m = getmin(0, 0, n, i, r + 1);
		int as = r - i + 1;
		if (sum - m >= half) as--;
		if (ans > as && sum >= half) {
			//cout << i << " " << r << " " << sum << "\n";
			ans = min(ans, as);
		}
		sum -= a[i];
	}
	cout << ans;
}