#include<bits/stdc++.h>

using namespace std;

using ll = long long;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()

int dx[] = {1, 1, -1, -1};
int dy[] = {-1, 1, 1, -1};


int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    vector<vector<int>> b(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            b[i][j] = a[i][j];
            a[i][j] %= 2;
            a[i][j] ^= 1;
        }
    }
    auto check = [&](int x, int y) -> bool {
        if (0 <= x && x < n && 0 <= y && y < m) {
            return a[x][y];
        }
        return 1;
    };
    vector<pair<int, int>> tr;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            bool ok = 1;
            for (int c = 0; c < 4; ++c) ok &= check(i + dx[c], j + dy[c]);
            if (ok) {
                tr.emplace_back(i, j);
            }
        }
    }
    auto go = [&](int x, int y) {
        vector<vector<int>> c(n, vector<int>(m));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (i - j == x - y) {
                    if (i <= x) c[i][j] = 4;
                    else c[i][j] = 8;
                } else if (i + j == x + y) {
                    if (i <= x) c[i][j] = 6;
                    else c[i][j] = 2;
                } else {
                    int d = x - i;
                    int d2 = y - j;
                    if (abs(d) < abs(d2)) {
                        if (d2 < 0) {
                            c[i][j] = 7;
                        } else {
                            c[i][j] = 3;
                        }
                    } else {
                        if (d < 0) {
                            c[i][j] = 1;
                        } else {
                            c[i][j] = 5;
                        }
                    }
                }
            }
        }
        vector<int> cntr(n), cntc(m);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (i == x && j == y) continue;
                cntr[i] += (c[i][j] != b[i][j]);
                cntc[j] += (c[i][j] != b[i][j]);
            }
        }

        int a = max_element(all(cntr)) - cntr.begin(), bb = max_element(all(cntc)) - cntc.begin();
        bool ok = 1;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (i == x || j == y) continue;
                int val = c[i][j];
                if (i == a || j == bb) {
                    val = val + 4;
                    if (val > 8) val -= 8;
                }
                ok &= val == b[i][j];
            }
        }
        if (ok) {
            cout << x + 1 << ' ' << y + 1 << '\n';
            cout << a + 1 << ' ' << bb + 1 << '\n';
            exit(0);
        }
    };
    for (auto [x, y] : tr) go(x, y);
};
//ABAABA