#include<bits/stdc++.h>
using namespace std;

using ll = long long;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()

struct f {

    f() {}
    f(ll k, ll b) : k(k), b(b) {}

    ll get(ll x) {
        return k * x + b;
    }

    ll k, b;

};

ll intersect(f a, f b) {
    assert(a.k != b.k);
    return (b.b - a.b) / (a.k - b.k);
}

int geti(int x1, int y1, int x2, int y2, int X, int Y) {
    if (Y == y1 && x1 < X) return 1;
    if (X == x2 && y1 < Y) return 2;
    if (Y == y2 && X < x2) return 3;
    return 4;
}

int dist(int x1, int y1, int x2, int y2, int X1, int Y1, int X2, int Y2) {
    int ans = 0;
    while (geti(x1, y1, x2, y2, X1, Y1) != geti(x1, y1, x2, y2, X2, Y2)) {
        int k = geti(x1, y1, x2, y2, X1, Y1);
        cerr << k << "\n";
        if (k == 2) {
            ans += y2 - Y1 + 1;
            Y1 = y2;
            X1 = x2 + 1;
        } else if (k == 3) {
            ans += X1 - x1 + 1;
            X1 = x1;
            Y1 = y2 - 1;
        } else if (k == 4) {
            ans += y2 - Y1 + 1;
            Y1 = y2;
            X1 = x2 - 1;
        } else {
            ans += X1 - x1 + 1;
            X1 = x1;
            Y1 = Y2 - 1;
        }
    }
    ans += abs(X1 - X2) + abs(Y1 - Y2);
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    ll x1, y1, x2, y2, x3, y3;
    cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;

    vector<pair<ll, ll>> xs(n);
    for (int i = 0; i < n; i++) {
         cin >> xs[i].first >> xs[i].second;
    }

    ll ans = -1;

    {

        vector<pair<f, f>> h(n);
        for (int i = 0; i < n; i++) {
            ll k = 2 * (x2 - x1 + y2 - y1 + 4 * (i + 1));
            h[i].first = f(k, dist(x1, y1, x2, y2, xs[i].first, xs[i].second, x3, y1 - i));
            h[i].second = f(k, dist(x1, y1, x2, y2, xs[i].first, xs[i].second, x3, y2 + i));
            cerr << h[i].first.k << " " << h[i].first.b << " " << h[i].second.k << " " << h[i].second.b << "\n";
        }

        for (int mask = 0; mask < (1 << n); mask++) {
            bool good = true;
            ll pre = -1;
            for (int i = 1; i < n; i++) {
                auto f1 = (((mask >> (i - 1)) & 1) ? h[i - 1].second : h[i - 1].first);
                auto f2 = (((mask >> i) & 1) ? h[i].second : h[i].first);

                ll x = intersect(f1, f2);

                if (x < 0 || (pre != -1 && pre != x)) {
                    good = false;
                    break;
                }
                pre = x;
            }

            if (good && (ans == -1 || ans > pre)) ans = pre;
        }

    }

    {

        vector<pair<f, f>> v(n);
        for (int i = 0; i < n; i++) {
            ll k = 2 * (x2 - x1 + y2 - y1 + 4 * (i + 1));
            v[i].first = f(k, dist(x1, y1, x2, y2, xs[i].first, xs[i].second, x1 - i, y3));
            v[i].second = f(k, dist(x1, y1, x2, y2, xs[i].first, xs[i].second, x2 + i, y3));
        }

        for (int mask = 0; mask < (1 << n); mask++) {
            bool good = true;
            ll pre = -1;
            for (int i = 1; i < n; i++) {
                auto f1 = (((mask >> (i - 1)) & 1) ? v[i - 1].second : v[i - 1].first);
                auto f2 = (((mask >> i) & 1) ? v[i].second : v[i].first);

                ll x = intersect(f1, f2);

                if (x < 0 || (pre != -1 && pre != x)) {
                    good = false;
                    break;
                }
                pre = x;
            }

            if (good && (ans == -1 || ans > pre)) ans = pre;
        }

    }

    cout << ans;

}
//ABAABA