#include <iostream>
#include <vector>
#include <set>
using namespace std;
typedef long long ll;

const int INF = 1e9;

int main() {
    int n; cin >> n;
    vector<pair<int, set<int>>> dp(max(6, n + 1), {INF, {}});
    dp[1] = {0, {1}};
    dp[2] = {1, {2}};
    dp[3] = {1, {1, 2}};
    dp[4] = {3, {1, 3}};
    dp[5] = {4, {3, 2}};
    for (int i = 6; i < dp.size(); i++) {
        for (int j = 1; j < i; j++) {
            if (dp[i - j].second.count(j) == 0) {
                if (dp[i - j].first + j * (j - 1) / 2 < dp[i].first) {
                    dp[i].first = dp[i - j].first + j * (j - 1) / 2;
                    dp[i].second = dp[i-j].second;
                    dp[i].second.insert(j);
                }
            }
        }
    }
    cout << dp[n].first << "\n";
}
