import java.io.*;
import java.util.*;

public class ProblemH {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
        int n = Integer.parseInt(reader.readLine());
        String str = reader.readLine();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) a[i] = str.charAt(i) == 'A' ? 0 : 1;
        int[] h = res(a);
        for (int i = 0; i < n + 1; i++) writer.write(h[i] + " ");
        writer.flush();
    }

    private static int[] res(int[] a) {
        int n = a.length;
        int[] h = new int[n + 1];
        int as = 0;
        for (int i = 0; i < n; i++) if (a[i] == 0) as++;
        int mid = as / 2;
        int i = 0, asi = 0;
        int count = 0;
        for (; i < n; i++) {
            if (a[i] == 0) {
                asi++;
                if (h[i] == 0) count++;
                h[i] = count;
                h[i + 1] = ++count;
                if (asi == mid + 1) break;
            }
        }
        count = n + 1;
        for (; i < n; i++) {
            if (a[i] == 0) {
                if (i > mid && h[i] == 0) count--;
                h[i] = count;
                h[i + 1] = --count;
            }
        }
        Set<Integer> set = new HashSet<>();
        for (i = 1; i <= n + 1; i++) set.add(i);
        for (i = 0; i < n + 1; i++) set.remove(h[i]);
        List<Integer> list = new ArrayList<>(set);
        int c = 0;
        for (i = 0; i < n + 1; i++) if (h[i] == 0) h[i] = list.get(c++);
        return h;
    }
}