#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define int int64_t

using namespace std;

int sum(int n) {
    if (n < 0)
        return 0;
    int s = 0;
    for (int h = 10, i = 2; h <= n; h *= 10, i++)
        s += (min(n + 1, 10 * h) - h) * i;
    return s + min(10ll, n + 1);
}

void solve() {
//    cout << sum(1e3) << '\n';
//    cout << 10 + 900 * 3 + 90 * 2 + 4;
//    return;
    int s, res = 0, hl = 1e18, hr = 1e18;
    cin >> s;
    for (int i = -1; i < 1e5; i++) {
        int lo = 0, hi = 1e18, a = sum(i);
//        int lo = 0, hi = 10, a = sum(i);
        while (lo + 1 < hi) {
            int u = (lo + hi) / 2;
//            cout << u << ' ' << sum(u) << '\n';
            if (s < sum(u) - a)
                hi = u;
            else
                lo = u;
        }
        if (sum(lo) - a == s && res < lo - i)
            hl = i + 1, hr = lo, res = lo - i;
//        cout << '\n';
    }
    if (res == 0)
        return void(cout << -1);
    cout << res << '\n';
    cout << hl << ' ' << hr << '\n';
}

int32_t main() {
#ifdef BIBIKOV
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif

    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }

    return 0;
}
