#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
template<class T> using oset = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define int ll
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()

const int INF = -2147483647;

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

int value(int x1, int y1, int x2, int y2) {
    if (x2 == x1 && y2 == y1) return 0;
    int dx = x2 - x1, dy = y2 - y1;
    if (dy == -dx) {
        if (dy > 0) return 6;
        if (dy < 0) return 2;
    }
    if (dy == dx) {
        if (dy > 0) return 8;
        if (dy < 0) return 4;
    }
    if (abs(dy) < abs(dx)) {
        if (dx < 0) return 5;
        if (dx > 0) return 1;
    }
    if (abs(dy) > abs(dx)) {
        if (dy > 0) return 7;
        if (dy < 0) return 3;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m;
    cin >> n >> m;
    vector<vector<int>> a(n,vector<int>(m,0));
    int diag1 = INF, diag2 = INF;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int k;
            cin >> k;
            a[i][j] = k;
            if (k % 4 == 2) diag1 = i + j;
            if (k % 4 == 0) diag2 = j - i;
        }
    }
    //cout << diag1 << " " << diag2 << endl;
    int magn_x = -1, magn_y = -1;
    if (diag1 != INF && diag2 != INF) {
        magn_y = (diag1 + diag2) / 2;
        magn_x = (diag1 - diag2) / 2;
    } else {
        int k = min(n,m);
        int i1 = k - 1, i2 = n - k + 1, i3 = m - k + 1;
        if (a[i1][i1]  % 2 == 0) {
            magn_x = 0;
            magn_y = 0;
        }
        if (a[i2][i1] % 2  == 0) {
            magn_x = n - 1;
            magn_y = 0;
        }
        if (a[i1][i3] % 2 == 0) {
            magn_x = 0;
            magn_y = m - 1;

        }
        if (a[i2][i3] % 2 == 0) {
            magn_x = n - 1;
            magn_y = m - 1;
        }
    }
    vector<int> flt_rows(n,0), flt_cols(m,0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == magn_x && j == magn_y) {
                flt_rows[i]++;
                flt_cols[j]++;
                continue;
            }
            if (value(magn_x,magn_y,i,j) != a[i][j]) {
                flt_rows[i]++;
                flt_cols[j]++;
            }
        }
    }
    //cout << flt_rows << flt_cols;
    int flt_row, flt_col;
    for (int i = 0; i < n; i++) if (flt_rows[i] > 1) flt_row = i;
    for (int i = 0; i < m; i++) if (flt_cols[i] > 1) flt_col = i;
    cout << magn_x + 1 << " " << magn_y + 1 << endl << flt_row + 1 << " " << flt_col + 1 << endl;

}

/*
3 4
5 6 3 7
3 7 3 7
5 4 3 3

3 2
1 5
1 6
6 3

2 3
3 3 2
3 2 1
 */
