#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
template<class T> using oset = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
#define int ll
using ld = long double;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()
const ld EPS = 1e-10;
struct Point {
    int x, y;
    Point(){

    }
    Point(int X, int Y) {
        x = X;
        y = Y;
    }
    int operator *(Point a) {
        return x * a.x + y * a.y;
    }
    int operator %(Point a) {
        return x * a.y - y * a.x;
    }
    Point operator -(Point a) {
        return {x - a.x, y - a.y};
    }
    Point operator +(Point a) {
        return {x + a.x, y + a.y};
    }
};
istream &operator>>(istream &in, Point &a) {
    in >> a.x >> a.y;
    return in;
}
ld len(Point a, Point b) {
    return sqrtl((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}
ld len(Point a) {
    return sqrtl(a.x * a.x + a.y * a.y);
}
//(min(a.x, b.x) <= min(c.x, d.x) && max(a.x, b.x) >= min(c.x, d.x)) && min(c.x, d.x) <= max(a.x, b.x) && max(a.x, b.x) <= max(c.x, d.x)
bool checkProj(Point a, Point b, Point c, Point d) {
    return (min(a.x, b.x) <= c.x && max(a.x, b.x) >= c.x) || (min(a.x, b.x) <= d.x && max(a.x, b.x) >= d.x);
}
bool getIntersect(Point a, Point b, Point c, Point d) {
    if (((c - d) % (b - d)) * ((c - d) % (a - d)) <= 0 && ((b - a) % (d - a)) * ((b - a) % (c - a)) <= 0 && checkProj(a,b,c,d)) {
        return true;
    } else {
        return false;
    }
}
ld dist_P(Point a, Point b, Point c) {
    if ((a - c) * (b - c) < 0 || (a - b) * (c - b) < 0) {
        return min(len(b,a), len(c,a));
    } else {
        return abs((c - b) % (a - b)) / len(b,c);
    }
}
ld min_dist(Point a, Point b, Point c, Point d) {
    if (getIntersect(a,b,c,d)) {
        return 0;
    } else {
        return min({dist_P(a, c, d), dist_P(b ,c, d), dist_P(c , a, b), dist_P(d, a, b)});
    }
}
signed main() {
/*    ios::sync_with_stdio(false);
    cin.tie(nullptr);*/

    int n;
    cin >> n;
    vector<pair<Point, Point>> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i].first >> s[i].second;
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                if (min_dist(s[i].first, s[i].second, s[j].first, s[j].second) - EPS <= len(s[k].first, s[k].second) ||
                    min_dist(s[j].first, s[j].second, s[k].first, s[k].second) - EPS <= len(s[i].first, s[i].second) ||
                    min_dist(s[k].first, s[k].second, s[i].first, s[i].second) - EPS <= len(s[j].first, s[j].second)) {
                    ans++;
                }
            }
        }
    }
    cout << ans << '\n';
}
/*
4
1 1 2 3
1 3 2 1
3 1 4 3
2 6 3 6
*/