#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
typedef long long LL;

long long f(long long a)
{
	long long res = 0;
	if (a == 0)
		return 1;
	while (a > 0)
	{
		a /= 10;
		res++;
	}
	return res;
}

long long F(vector<long long>& q)
{
	long long sum = 0;
	if (!q.empty())
	{
		if (f(q[0]) != f(q[q.size() - 1]))
		{
			long long mins = f(q[0]),
				maxs = f(q[q.size() - 1]),
				p = (pow(10, mins) - q[0]) * mins,
				p1 = (q[q.size() - 1] - pow(10, maxs - 1) + 1) * maxs;
long long n = f(q[0]) + 1;
			while (n < maxs)
			{
				sum += 9 * (long long)(pow(10, n - 1)) * n;
				n++;
			}
			sum += p;
			if (mins != maxs)
				sum += p1;
		}
		else
		{
			long long res = 0;
			for (auto i : q)
			{
				if (i == 0)
					res++;
				while (i > 0)
				{
					i /= 10;
					res++;
				}
			}
			return res;
		}

	}
	return sum;
}

int main(void)
{
	long long s;
	cin >> s;
	vector<long long> q;
	long long i = 0;
	while (F(q) < s)
		q.push_back(i++);
	long long delta = F(q) - s;
	while (!q.empty() && delta != 0)
	{
		if (delta >= f(q[q.size() - 1]))
		{
			delta -= f(q[q.size() - 1]);
			q.pop_back();
		}
		else
		{
			delta -= f(q[0]);
			q.erase(q.begin());
		}
	}
	if (q.empty())
	{
		cout << -1;
		return 0;
	}
	cout << q.size() << '\n';
	cout << q[0] << " " << q[q.size()-1];
	return 0;
}