//#pragma GCC optimize("03")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("avx,avx2,bmi2,fma")
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);

using namespace std;

typedef unsigned long long ll;


struct dat{
    unsigned long long l;
    unsigned long long r;
    unsigned long long sum;
};

int main() {
    unsigned long long n;
    cin>>n;
    vector<unsigned long long> a(n, 0);

    unsigned long long val = 0;

    for(unsigned long long i = 0;i<n;i++){
        cin>>a[i];
        val+=a[i];
    }

    val = ceil(float(val)/2);

    unsigned long long l = 0;
    unsigned long long r = 0;

    unsigned long long sum = a[0];

    vector<dat> ans;

    unsigned long long imin = 1e9;

    while(r<n&& l<n){
        if(sum>=val){

            if(r-l<imin){
                ans.clear();
                ans.push_back({l, r, sum});
                imin = r-l;
            }
            if(r-l == imin){
                ans.push_back({l, r, sum});
            }
            sum-=a[l];
            l++;
        }
        else{
            r++;
            sum+=a[r];
        }
    }


    bool can_delete = false;

    unsigned long long res = ans[0].r-ans[0].l+1;

    for(unsigned long long i = 0;i<ans.size();i++){
        unsigned long long diff = -val + ans[i].sum;
        l = ans[i].l;
        r = ans[i].r;

        unsigned long long mn = 1e9;

        for(unsigned long long j = l;j<=r;j++){
            mn = min(mn, a[j]);
        }
        if(mn<=diff){
            can_delete = true;
            res--;
            break;
        }
    }

    cout<<res<<endl;
}
