#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <string>

using namespace std;

#define vec vector
#define forn(i, n) for(int i = 0; i < n; i++)


typedef long long ll;

int n;
ll M = 1e9 + 33, p = 57;


vector <string> a;
vector <vector<ll>> h;

bool func(int k) {
	if (k == 0) return 1;
	map <int, int> mp;

	for (int i = 0; i < n; i++) {
		mp[h[i][k - 1]]++;
	}

	bool fl = 1;
	for (auto p : mp) if (p.second % 2 == 1) fl = 0;
	return fl;
}

void solve() {
	string s;
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> s;
		a.push_back(s);
	}
	h.resize(n, vector <ll>(s.size()));
	for (int i = 0; i < n; i++) {
		h[i][0] = a[i][0];
		for (int j = 1; j < s.size(); j++) {
			h[i][j] = (h[i][j - 1] * p + a[i][j]) % M;
		}
	}

	int l = 0, r = n + 1, m;

	while (r - l > 1) {
		m = (l + r) / 2;
		if (func(m)) l = m;
		else r = m;
	}
	cout << l;

}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}