#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <cmath>

using namespace std;
typedef long long LL;

inline int min(int a, int b)
{
  return a < b ? a : b;
}

inline int max(int a, int b)
{
  return a > b ? a : b;
}
/*
#define CHECK_BIT(N, Num) ((N >> Num) & 1)

LL FirstBits(LL Num, LL *LastBits, LL *ZeroNumber)
{
  int n = sizeof(LL) * 8 - 1;
  int cnt = 0;

  while (!CHECK_BIT(Num, n))
    n--;

  while (CHECK_BIT(Num, n))
    cnt++, n--;

  *LastBits = n;

  *ZeroNumber = 0;
  while (!CHECK_BIT(Num, n) && n >= 0)
    (*ZeroNumber)++, n--;

  return cnt;
}

int main(void)
{
  LL Num;

  cin >> Num;

  while (Num--)
  {
    LL Steps = 0;
    LL X;

    cin >> X;

    LL Dist = abs(X);

    while (Dist != 0)
    {
      LL FirstCnt, LastPos, ZNum;
      FirstCnt = FirstBits(Dist, &LastPos, &ZNum);

      Dist &= (2 << LastPos) - 1;

      if (FirstCnt > 1)
        Steps += 2;
      else
        Steps += 1;
      if (ZNum == 1)
        Steps--;

      if (LastPos < 0)
        Dist = 0;
    }
    cout << Steps << endl;
  }
  return 0;
}
*/
/*
//                              x  , i
std::map<std::string, std::pair<int, int>> A;


bool IsOnWay(const string& Ai, const string& Ax)
{
  if (Ai.size() > Ax.size())
    return 0;
  for (int i = 0; i < (int)Ai.size(); i++)
  {
    if (Ai[i] != Ax[i])
      return 0;
  }
  return 1;
}

int main(void)
{
  LL q, c;

  cin >> q;
  cin >> c;

  for (int i = 0; i <= q; i++)
  {
    int Comand, x;
    cin >> Comand;

    if (Comand == 1)
    {
      cin >> x;

      string Way;
      cin >> Way;

      A[Way] = {x, i};
    }
    else if (Comand == 2)
    {
      string OWay {};
      pair<int, int> OCom;

      string XWay;
      cin >> XWay;

      for (auto& Ai : A)
      {
        if (IsOnWay(Ai.first, XWay))
        {
          if (OWay == "")
            OWay = Ai.first, OCom = Ai.second;
          else if (OCom.second < Ai.second.second)
            OWay = Ai.first, OCom = Ai.second;
        }
      }

      if (OWay == "")
        cout << -1 << endl;
      else
      {
        int TempWayI = OWay.size();
        LL OutColor = OCom.first;

        while (TempWayI < (int)XWay.size())
        {
          if (XWay[TempWayI] == 'L')
            OutColor = (OutColor + 1) % c;
          else if (XWay[TempWayI] == 'R')
            OutColor = (OutColor - 1 + c) % c;
          TempWayI++;
        }
        cout << OutColor << endl;
      }
    }

  }
  return 0;
}
*/

vector<string> W;
typedef int WP;
map<int, map<WP, WP>> Cnts;

int compare(WP a, WP b)
{
  for (int i = 0; i < W[a].size(); i++)
    if (W[a] != W[b])
      return i + 1;
  return W[a].size();
}

bool IsSame(WP a, WP b, int n)
{
  for (int i = 0; i < n; i++)
    if (W[a][i] != W[b][i])
      return false;
  return true;
}

void ReadWords()
{
  int Cnt, i;

  cin >> Cnt;
  i = Cnt;
  W.resize(Cnt);
  while (i--)
    cin >> W[i];
}

int main(void)
{
  ReadWords();
  for (int i = W[0].size(); i > 0; i--)
  {
    vector<bool> Used;
    Used.resize(W.size());

    for (WP f = 0; f < W.size(); f++)
    {
      if (Used[f])
        continue;

      for (WP s = f + 1; s < W.size(); s++)
      {
        if (Used[s])
          continue;

        if (IsSame(f, s, i))
          Used[f] = Used[s] = true;
      }
    }

    bool iffu = true;
    for (auto i : Used)
      iffu &= i;
    if (iffu)
    {
      cout << i << endl;
      return 0;
    }
  }

  cout << 0 << endl;
  return 0;
}

/*
vector<string> W;
map<int, int> Sizes; //letters, number of pairs

int Compare(int a, int b)
{
  for (int i = 0; i < W[a].size() && i < W[b].size(); i++)
    if (W[a][i] != W[b][i])
      return i;

  return min(W[a].size(), W[b].size());
}

void ReadWords()
{
  int Cnt, i;

  cin >> Cnt;
  i = Cnt;
  W.resize(Cnt);
  while (i--)
    cin >> W[i];
}

void EvalCounts()
{
  for (int f = 0; f < W.size(); f++)
    for (int s = f + 1; s < W.size(); s++)
    {
      int ccn = Compare(f, s);

      while (ccn > 0)
        Sizes[ccn--]++;
    }
}

int EvalSizes()
{
  int pairs = 0;
  for (auto i : Sizes)
    pairs = max(i.second, pairs);
  return pairs;
}

int main(void)
{
  ReadWords();
  EvalCounts();
  cout << EvalSizes() << endl;
 
  return 0;
}
*/