#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define int long long
struct Hash1 {
    const int M = 1e9 + 7;
    const int B = 31;
    vector<ll> h, pw;
    void init(string s) {
        int n = s.size();
        h.assign(n + 1, 0);
        pw.assign(n + 1, 1);
        for (int i = 0; i < n; ++i) {
            pw[i + 1] = (pw[i] * B) % M;
            h[i + 1] = (h[i] * B + (s[i] - 'a' + 1)) % M;
        }
    }
    ll get(int l, int r) {
        ll res = (h[r] - h[l] * pw[r - l]) % M;
        if (res < 0)
            res += M;
        return res;
    }
};
struct Hash2 {
    const int M = 1e9 + 123;
    const int B = 37;
    vector<ll> h, pw;
    void init(string s) {
        int n = s.size();
        h.assign(n + 1, 0);
        pw.assign(n + 1, 1);
        for (int i = 0; i < n; ++i) {
            pw[i + 1] = (pw[i] * B) % M;
            h[i + 1] = (h[i] * B + (s[i] - 'a' + 1)) % M;
        }
    }
    ll get(int l, int r) {
        ll res = (h[r] - h[l] * pw[r - l]) % M;
        if (res < 0)
            res += M;
        return res;
    }
};
signed main() {
    int n;
    cin >> n;
    vector<string> a(n);
    for (auto &x : a)
        cin >> x;
    vector<pair<Hash1, Hash2>> hs(n);
    for (int i = 0; i < n; ++i) {
        hs[i].first.init(a[i]);
        hs[i].second.init(a[i]);
    }
    auto check = [&](int k) -> bool {
        map<pair<ll, ll>, int> m;
        for (int i = 0; i < n; ++i) {
            m[{hs[i].first.get(0, k), hs[i].second.get(0, k)}]++;
        }
        int res = 0;
        for (auto p : m) {
            res += p.second / 2;
        }
        return res == n / 2;
    };
    for (int size = a[0].size(); size >= 0; --size) {
        if (check(size)) {
            cout << size << '\n';
            return 0;
        }
    }
    return 0;
}
